;************************************************************************
;*									*
;*	DV-GLUE		DESQview and DESQview/X Function Library	*
;*			(c) Copyright 1992 Ralf Brown			*
;*			All Rights Reserved.				*
;*									*
;*	File FLDQRY.ASM		Query Streams relating to fields	*
;*									*
;************************************************************************
;LastEdit: 12/29/92

	INCLUDE API.INC
	INCLUDE DVSTREAM.INC
	MIN_VERSION 2,00

	Header@

;========================================================================

DSeg@
S_QUERY		header_stream
	db 0FCh
	db 0,0,0,0,0,0
	S_END	header_stream

S_QUERY		entry_stream
	db 0F5h
	db 0,0,0,0,0,0,0,0
	S_END	entry_stream

S_QUERY		type_stream
	QS_FLDTYPE
	S_END	type_stream

DSegEnd@

;========================================================================

CSeg@

;------------------------------------------------------------------------

PubProc@ DVQRY_ENTRY,__PASCAL__
@win = dword ptr [bp+SendOverhead+2+dPtrSize]
@field = word ptr [bp+SendOverhead+dPtrSize]
@entry = DPTR_ [bp+SendOverhead]
	@EnterSend
	STACK_STREAM DGROUP:entry_stream
	mov	al,byte ptr @field
	mov	SS_[bx+5],al
	push	bx			; remember stream's address
	WIN_STREAM @win,ss,bx
	pop	bx			; retrieve address of stream
	mov	cx,SS_[bx+2]		; length of stream
	dec	cx			; don't copy opcode
	dec	cx			;   or field number
	add	bx,6			; point at returned data
	LES_	di,@entry
entry_loop:
	mov	al,SS_[bx]
	inc	bx
	mov	ES_[di],al
	inc	di
	loop	entry_loop
	@ExitSend 6+dPtrSize
EndProc@ DVQRY_ENTRY,__PASCAL__

;------------------------------------------------------------------------

PubProc@ DVQRY_HEADER,__PASCAL__
@win = dword ptr [bp+SendOverhead+dPtrSize]
@header = DPTR_ [bp+SendOverhead]
	@EnterSend
	STACK_STREAM DGROUP:header_stream
	push	bx			; remember stream's address
	WIN_STREAM @win,ss,bx
	pop	bx			; retrieve address of stream
	mov	cx,SS_[bx+2]		; length of stream
	dec	cx			; don't copy opcode
	add	bx,5			; point at returned data
	LES_	di,@header
header_loop:
	mov	al,SS_[bx]
	inc	bx
	mov	ES_[di],al
	inc	di
	loop	header_loop
	@ExitSend 4+dPtrSize
EndProc@ DVQRY_HEADER,__PASCAL__

;------------------------------------------------------------------------

PubProc@ DVQRY_FIELDSIZE,__PASCAL__
@win = dword ptr [bp+4+cPtrSize]
@fld = word ptr [bp+2+cPtrSize]
; local variables
@ftentry = byte ptr [bp-size FT_ENTRY]
	push	bp
	mov	bp,sp
	sub	sp,size FT_ENTRY
	mov	bx,sp
	PUSHMEM32 @win
	push	word ptr @fld
	PUSHDPTR ss,bx
	call	DVQRY_ENTRY@
	xor	ax,ax
	mov	al,@ftentry.fte_lowrightrow
	sub	al,@ftentry.fte_upleftrow
	inc	ax
	xor	bx,bx
	mov	bl,@ftentry.fte_lowrightcol
	sub	bl,@ftentry.fte_upleftcol
	inc	bx
	mul	bx			; DX:AX <- number of positions in field
	mov	sp,bp			; pop local vars off stack
	pop	bp
	ret	6
EndProc@ DVQRY_FIELDSIZE,__PASCAL__

;------------------------------------------------------------------------

PubProc@ DVQRY_TYPE,__PASCAL__
@win = dword ptr [bp+SendOverhead+2]
@fld = word ptr [bp+SendOverhead]
	@EnterSend
	STACK_STREAM DGROUP:type_stream
	push	bx			; remember stream address
	mov	al,byte ptr @fld
	mov	SS_[bx+5],al
	WIN_STREAM @win,ss,bx
	pop	bx			; retrieve address of stream
	xor	ax,ax
	mov	al,SS_[bx+6]
	@ExitSend 6
EndProc@ DVQRY_TYPE,__PASCAL__

CSegEnd@

	END
